//go:build !disable_pgv

// Code generated by protoc-gen-validate. DO NOT EDIT.
// source: envoy/extensions/filters/common/set_filter_state/v3/value.proto

package set_filter_statev3

import (
	"bytes"
	"errors"
	"fmt"
	"net"
	"net/mail"
	"net/url"
	"regexp"
	"sort"
	"strings"
	"time"
	"unicode/utf8"

	"google.golang.org/protobuf/types/known/anypb"
)

// ensure the imports are used
var (
	_ = bytes.MinRead
	_ = errors.New("")
	_ = fmt.Print
	_ = utf8.UTFMax
	_ = (*regexp.Regexp)(nil)
	_ = (*strings.Reader)(nil)
	_ = net.IPv4len
	_ = time.Duration(0)
	_ = (*url.URL)(nil)
	_ = (*mail.Address)(nil)
	_ = anypb.Any{}
	_ = sort.Sort
)

// Validate checks the field values on FilterStateValue with the rules defined
// in the proto definition for this message. If any rules are violated, the
// first error encountered is returned, or nil if there are no violations.
func (m *FilterStateValue) Validate() error {
	return m.validate(false)
}

// ValidateAll checks the field values on FilterStateValue with the rules
// defined in the proto definition for this message. If any rules are
// violated, the result is a list of violation errors wrapped in
// FilterStateValueMultiError, or nil if none found.
func (m *FilterStateValue) ValidateAll() error {
	return m.validate(true)
}

func (m *FilterStateValue) validate(all bool) error {
	if m == nil {
		return nil
	}

	var errors []error

	// no validation rules for FactoryKey

	// no validation rules for ReadOnly

	// no validation rules for SharedWithUpstream

	// no validation rules for SkipIfEmpty

	oneofKeyPresent := false
	switch v := m.Key.(type) {
	case *FilterStateValue_ObjectKey:
		if v == nil {
			err := FilterStateValueValidationError{
				field:  "Key",
				reason: "oneof value cannot be a typed-nil",
			}
			if !all {
				return err
			}
			errors = append(errors, err)
		}
		oneofKeyPresent = true

		if utf8.RuneCountInString(m.GetObjectKey()) < 1 {
			err := FilterStateValueValidationError{
				field:  "ObjectKey",
				reason: "value length must be at least 1 runes",
			}
			if !all {
				return err
			}
			errors = append(errors, err)
		}

	default:
		_ = v // ensures v is used
	}
	if !oneofKeyPresent {
		err := FilterStateValueValidationError{
			field:  "Key",
			reason: "value is required",
		}
		if !all {
			return err
		}
		errors = append(errors, err)
	}
	oneofValuePresent := false
	switch v := m.Value.(type) {
	case *FilterStateValue_FormatString:
		if v == nil {
			err := FilterStateValueValidationError{
				field:  "Value",
				reason: "oneof value cannot be a typed-nil",
			}
			if !all {
				return err
			}
			errors = append(errors, err)
		}
		oneofValuePresent = true

		if all {
			switch v := interface{}(m.GetFormatString()).(type) {
			case interface{ ValidateAll() error }:
				if err := v.ValidateAll(); err != nil {
					errors = append(errors, FilterStateValueValidationError{
						field:  "FormatString",
						reason: "embedded message failed validation",
						cause:  err,
					})
				}
			case interface{ Validate() error }:
				if err := v.Validate(); err != nil {
					errors = append(errors, FilterStateValueValidationError{
						field:  "FormatString",
						reason: "embedded message failed validation",
						cause:  err,
					})
				}
			}
		} else if v, ok := interface{}(m.GetFormatString()).(interface{ Validate() error }); ok {
			if err := v.Validate(); err != nil {
				return FilterStateValueValidationError{
					field:  "FormatString",
					reason: "embedded message failed validation",
					cause:  err,
				}
			}
		}

	default:
		_ = v // ensures v is used
	}
	if !oneofValuePresent {
		err := FilterStateValueValidationError{
			field:  "Value",
			reason: "value is required",
		}
		if !all {
			return err
		}
		errors = append(errors, err)
	}

	if len(errors) > 0 {
		return FilterStateValueMultiError(errors)
	}

	return nil
}

// FilterStateValueMultiError is an error wrapping multiple validation errors
// returned by FilterStateValue.ValidateAll() if the designated constraints
// aren't met.
type FilterStateValueMultiError []error

// Error returns a concatenation of all the error messages it wraps.
func (m FilterStateValueMultiError) Error() string {
	var msgs []string
	for _, err := range m {
		msgs = append(msgs, err.Error())
	}
	return strings.Join(msgs, "; ")
}

// AllErrors returns a list of validation violation errors.
func (m FilterStateValueMultiError) AllErrors() []error { return m }

// FilterStateValueValidationError is the validation error returned by
// FilterStateValue.Validate if the designated constraints aren't met.
type FilterStateValueValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e FilterStateValueValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e FilterStateValueValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e FilterStateValueValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e FilterStateValueValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e FilterStateValueValidationError) ErrorName() string { return "FilterStateValueValidationError" }

// Error satisfies the builtin error interface
func (e FilterStateValueValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sFilterStateValue.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = FilterStateValueValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = FilterStateValueValidationError{}
