# py-mkopensource

`py-mkopensource` is a program for generating reports of the libraries
used by a Python application, in order to be in compliance with the
attribution requirements of various opensource licenses.

`py-mkopensource` takes as input the dependencies generated by 
`pip show`, and produces a report in either JSON or markdown output.

## Running

`py-mkopensource` requires `pip` and `pip-tools`.

To generate the list of dependencies from `requirements.txt`, run the 
following commands:

```shell
pip3 --disable-pip-version-check install -r requirements.txt
pip3 --disable-pip-version-check freeze --exclude-editable | cut -d= -f1 | xargs pip show | sed 's/^---$//' >dependenncies.txt
echo '' >>dependenncies.txt
cat dependenncies.txt | ./py-mkopensource
```

## Command line options

### Output type

Parameter `--output-type` controls the output format.

#### `--output-type=markdown`

Program outputs dependency information in Markdown format. 

This is the default value.

#### `--output-type=json`

Program outputs dependency information in JSON format
